<?php

/**
 * REX_LINK_BUTTON,
 * REX_LINK,
 * REX_LINK_ID,
 * REX_LINKLIST_BUTTON,
 * REX_LINKLIST
 *
 * @package redaxo4
 * @version $Id: class.rex_var_link.inc.php,v 1.21 2007/11/17 15:49:19 kristinus Exp $
 */

class rex_var_link extends rex_var
{
  // --------------------------------- Actions

  function getACRequestValues($REX_ACTION)
  {
    $values = rex_request('LINK', 'array');
    for ($i = 1; $i < 11; $i++)
    {
      if (!isset ($values[$i]))
        $values[$i] = '';

      $REX_ACTION['LINK'][$i] = stripslashes($values[$i]);
    }
    return $REX_ACTION;
  }

  function getACDatabaseValues($REX_ACTION, & $sql)
  {
    for ($i = 1; $i < 11; $i++)
    {
      $REX_ACTION['LINK'][$i] = $this->getValue($sql, 'link'. $i);
    }

    return $REX_ACTION;
  }

  function setACValues(& $sql, $REX_ACTION, $escape = false)
  {
    global $REX;

    for ($i = 1; $i < 11; $i++)
    {
      $this->setValue($sql, 'link'. $i, $REX_ACTION['LINK'][$i], $escape);
    }
  }

  // --------------------------------- Output

  function getBEOutput(& $sql, $content)
  {
    return $this->getOutput($sql, $content);
  }

  function getBEInput(& $sql, $content)
  {
    $content = $this->getOutput($sql, $content);
    $content = $this->matchLinkButton($sql, $content);
    $content = $this->matchLinkListButton($sql, $content);

    return $content;
  }

  function getOutput(& $sql, $content)
  {
    $content = $this->matchLinkList($sql, $content);
    $content = $this->matchLink($sql, $content);
    $content = $this->matchLinkId($sql, $content);

    return $content;
  }

  function getInputParams($content, $varname)
  {
    $matches = array ();
    $id = '';
    $category = '';

    $match = $this->matchVar($content, $varname);
    foreach ($match as $param_str)
    {
      $params = $this->splitString($param_str);

      foreach ($params as $name => $value)
      {
        switch ($name)
        {
          case '0' :
          case 'id' :
            $id = (int) $value;
            break;

          case '1' :
          case 'category' :
            $category = (int) $value;
            break;
        }
      }

      $matches[] = array (
        $param_str,
        $id,
        $category
      );
    }

    return $matches;
  }

  /**
   * Button fr die Eingabe
   */
  function matchLinkButton(& $sql, $content)
  {
  	global $REX;

  	$def_category = '';
  	$article_id = rex_request('article_id', 'int');
  	if($article_id != 0)
  	{
  		$art = OOArticle::getArticleById($article_id);
  		$def_category = $art->getCategoryId();
  	}

    $var = 'REX_LINK_BUTTON';
    $matches = $this->getInputParams($content, $var);
    foreach ($matches as $match)
    {
      list ($param_str, $id, $category) = $match;

      if ($id < 11 && $id > 0)
      {
      	// Wenn vom Programmierer keine Kategorie vorgegeben wurde,
      	// die Linkmap mit der aktuellen Kategorie ffnen
	      if($category == '') $category = $def_category;

        $replace = $this->getLinkButton($id, $this->getValue($sql, 'link' . $id), $category);
        $content = str_replace($var . '[' . $param_str . ']', $replace, $content);
      }
    }

    return $content;
  }

  /**
   * Button fr die Eingabe
   */
  function matchLinkListButton(& $sql, $content)
  {
    $var = 'REX_LINKLIST_BUTTON';
    $matches = $this->getInputParams($content, $var);
    foreach ($matches as $match)
    {
      list ($param_str, $id, $category) = $match;

      if ($id < 11 && $id > 0)
      {
        $replace = $this->getLinklistButton($id, $this->getValue($sql, 'linklist' . $id), $category);
        $content = str_replace($var . '[' . $param_str . ']', $replace, $content);
      }
    }

    return $content;
  }

  /**
   * Wert fr die Ausgabe
   */
  function matchLink(& $sql, $content)
  {
    $var = 'REX_LINK';
    $matches = $this->getOutputParam($content, $var);
    foreach ($matches as $match)
    {
      list ($param_str, $id) = $match;

      if ($id > 0 && $id < 11)
      {
      	$replace = '';
      	if ($this->getValue($sql, 'link' . $id)!="") 
      		$replace = rex_getUrl($this->getValue($sql, 'link' . $id));
      		
        $content = str_replace($var . '[' . $param_str . ']', $replace, $content);
      }
    }

    return $content;
  }

  /**
   * Wert fr die Ausgabe
   */
  function matchLinkId(& $sql, $content)
  {
    $var = 'REX_LINK_ID';
    $matches = $this->getOutputParam($content, $var);
    foreach ($matches as $match)
    {
      list ($param_str, $id) = $match;

      if ($id > 0 && $id < 11)
      {
        $replace = $this->getValue($sql, 'link' . $id);
        $content = str_replace($var . '[' . $param_str . ']', $replace, $content);
      }
    }

    return $content;
  }

  /**
   * Wert fr die Ausgabe
   */
  function matchLinkList(& $sql, $content)
  {
    $var = 'REX_LINKLIST';
    $matches = $this->getOutputParam($content, $var);
    foreach ($matches as $match)
    {
      list ($param_str, $id) = $match;

      if ($id > 0 && $id < 11)
      {
        $replace = $this->getValue($sql, 'linklist' . $id);
        $content = str_replace($var . '[' . $param_str . ']', $replace, $content);
      }
    }

    return $content;
  }

  /**
   * Gibt das Button Template zurck
   */
  function getLinkButton($id, $article_id, $category = '')
  {
    global $REX;

    $art_name = '';
    $clang = '';
    $art = OOArticle :: getArticleById($article_id);

    // Falls ein Artikel vorausgewhlt ist, dessen Namen anzeigen und beim ffnen der Linkmap dessen Kategorie anzeigen
    if (OOArticle :: isValid($art))
    {
      $art_name = $art->getName();
			$category = $art->getCategoryId();
    }

    $open_params = '&clang=' . $REX['CUR_CLANG'];
    if ($category != '')
      $open_params .= '&category_id=' . $category;

    $media = '
	<div class="rex-wdgt">
		<div class="rex-wdgt-lnk">
			<p>
  			<input type="hidden" name="LINK[' . $id . ']" id="LINK_' . $id . '" value="'. $article_id .'" />
  			<input type="text" size="30" name="LINK_NAME[' . $id . ']" value="' . $art_name . '" id="LINK_' . $id . '_NAME" readonly="readonly" />
  			<a href="#" onclick="openLinkMap(\'LINK_' . $id . '\', \'' . $open_params . '\');return false;"'. rex_tabindex() .'><img src="media/file_open.gif" width="16" height="16" alt="Open Linkmap" title="Open Linkmap" /></a>
 				<a href="#" onclick="deleteREXLink(' . $id . ');return false;"'. rex_tabindex() .'><img src="media/file_del.gif" width="16" height="16" title="Remove Selection" alt="Remove Selection" /></a>
 			</p>
 		</div>
 	</div>';

    return $media;
  }

  /**
   * Gibt das ListButton Template zurck
   * TODO: komplett berarbeiten
   */
  function getLinklistButton($id, $article_id, $category = '')
  {
    return "";
  }
}
?>